;-------------------------------------------------------------------------------
; Hogyan írjunk játékot ZX Spectrumra...
; 4. Fejezet - Véletlen számok
;-------------------------------------------------------------------------------
; Példaprogram 4.2
;-------------------------------------------------------------------------------
; Állítsuk is munkába új véletlen szám generátorunkat a Százlábú játékban! Minden
; Százlábú játéknak szüksége van gombákra – mégpedig meglehetősen sokra –, szétszórva
; a játéktérben. Jó szolgálatot fog tenni a fenti rutin a gombák koordinátáinak 
; véletlenszerű meghatározásához.
;-------------------------------------------------------------------------------
; SjAsmPlus v1.07rc verzióval fordítva
;-------------------------------------------------------------------------------

	DEVICE ZXSPECTRUM48

; ide fordítjuk a kódot (32768)
	.org $8000

; címke az sjasmplus számára a kódhossz számításához
start:
	
; Fekete képernyőt szeretnénk

	ld	a, 71		; fehér tinta (7) fekete papíron (0),
				; világosan (64)
	ld	(23693), a	; képernyő színek beállítása
	xor	a		; akkumulátor nullázásának gyors módja
	call	8859		; maradandó keretszín

; Grafika beállítása

	ld	hl, blocks	; felhasználói grafikus elemek címe
	ld	(23675), hl	; az UDG ide mutasson

; Rendben, kezdődjön a játék!

	call	3503		; ROM rutin – képernyő törlése, 2-es csat. nyitása

; Koordináták inicializálása

	ld	hl, 21+15*256	; kezdeti koordináták a HL-be
	ld	(plx), hl	; játékos koordinátái

	call	basexy		; x és y pozíciójának beállítása
	call	splayr		; játékos törzsének megjelenítése

; Feltöltjük a játékteret gombákkal

	ld	a, 68		; zöld tinta (4) fekete papíron (0),
				; világos színnel (64)
	ld	(23695), a	; ideiglenes szín beállítása
	ld	b, 50		; kezdetnek csak pár gomba
mushlp	ld	a, 22		; AT karakter vezérlőkódja
       rst	16
       call	random		; "véletlen" szám generálása
       and	15		; a [0..15] függőleges tartományban
       rst	16
       call	random		; újabb véletlen szám
       and	31		; a [0..31] vízszintes tartományban
       rst	16
       ld	a, 145		; UDG 'B' a gomba grafikája
       rst	16		; kihelyezzük a képernyőre
       djnz	mushlp		; ciklus amíg nem végeztünk a gombákkal

; Ez a főhurok

mloop 	equ $

; Játékos törlése

	call	basexy		; x és y pozíciójának beállítása
	call	wspace		; üres hely a játékos pozíciójába

; Törölve van a játékos, átmozgathatjuk az új pozícióba mielőtt újra
; megjelenítjük

	ld	bc, 63486	; billentyűk 1-5/joystick port 2
	in	a, (c)		; kiolvassuk a megnyomott gombokat
	rra			; legkülső bit = 1-es gomb
	push	af		; megjegyezzük
	call	nc, mpl		; ha megnyomva, mozgás balra
	pop	af		; akku helyreállítása
	rra			; következő bit (2-es helyiérték) = 2-es gomb
	push	af		; megjegyezzük
	call	nc, mpr		; ha megnyomva, mozgás jobbra
	pop	af		; akku helyreállítása
	rra			; következő bit (4-es helyiérték) = 3-es gomb
	push	af		; megjegyezzük
	call	nc, mpd		; ha megnyomva, mozgás lefelé
	pop	af		; akku helyreállítása
	rra			; következő bit (8-es helyiérték) = 4-es gomb
	call	nc, mpu		; ha megnyomva, mozgás felfelé

; Az átmozgatás megtörtént, újra megjeleníthetjük a játékost

	call	basexy		; x és y koordináta beállítása
	call	splayr		; játékos megjelenítése

	halt			; várakozás

; Visszaugrás a főhurok elejére

	jp	mloop

; Játékos balra mozgatása

mpl	ld	hl, ply		; Emlékezzünk, y a vízszintes koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	and	a		; Nulla?
	ret	z		; Ha igen, nem tudunk tovább balra menni!
	dec	(hl)		; különben y = y-1
	ret

; Játékos jobbra mozgatása

mpr	ld	hl, ply		; Emlékezzünk, y a vízszintes koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	cp	31		; A jobb szélén vagyunk (31)?
	ret	z		; Ha igen, nem tudunk tovább jobbra menni!
	inc	(hl)		; különben y = y+1
	ret

; Játékos felfelé mozgatása

mpu	ld	hl, plx		; Emlékezzünk, x a függőleges koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	cp	4		; a pálya tetején vagyunk (4)?
	ret	z		; Ha igen, nem tudunk tovább felfele menni!
	dec	(hl)		; különben x = x-1
	ret

; Játékos lefelé mozgatása

mpd	ld	hl,plx		; Emlékezzünk, x a függőleges koordináta!
	ld	a,(hl)		; Mi a mostani érték?
	cp	21		; A képernyő alján vagyunk (21)?
	ret	z		; Ha igen, nem tudunk tovább lefele menni!
	inc	(hl)		; különben x = x+1
	ret

; A játékos törzsének, x és y koordináta értékének beállítása,
; ez a rutin kerül meghívásra a törzs törlése és megjelenítése előtt

basexy	ld	a, 22		; AT pozícionáló kód
	rst	16
	ld	a, (plx)	; játékos függőleges koord
	rst	16		; beállítjuk
	ld	a, (ply)	; játékos vízszintes koord
	rst	16		; ezt is beállítjuk
	ret

; Megjelenítjük a játékost a jelenlegi PRINT pozícióban

splayr	ld	a, 69		; cián tinta (5) fekete papíron (0),
				; világosan (64)
	ld	(23695), a	; beállítjuk az ideiglenes színeket
	ld	a, 144		; 'A' UDG ASCII kódja
	rst	16		; játékos kirajzolása
	ret

wspace	ld	a, 71		; fehér tinta (7) fekete papíron (0),
				; világos (64)
	ld	(23695), a	; beállítjuk az ideiglenes színeket
	ld	a, 32		; SZÓKÖZ karakter
	rst	16		; üres hely megjelenítése
	ret

; Egyszerű pszeudo-véletlen szám generátor
; Egy mutatót léptet a ROM területen (a seed-ben tárolva), visszaadva
; a megcímzett bájt tartalmát

random	ld	hl, (seed)	; Mutató
	ld	a, h
	and	31		; Az első 8 KB-on belül tartjuk
	ld	h, a
	ld	a, (hl)		; „Véletlen” szám a mutatott helyről
	inc	hl		; Mutató léptetése
	ld	(seed), hl
	ret
seed	defw	0

plx	defb	0		; játékos x koordinátája
ply	defb	0		; játékos y koordinátája

; UDG grafika

blocks	defb 16,16,56,56,124,124,254,254	; játékos törzse
	defb 24,126,255,255,60,60,60,60		; mushroom


; címke az sjasmplus számára a kódhossz számításához
end:

; a lefordított bináris kódot elmenti
	.savebin "pelda_4_2.bin",start,end-start   
